SystemOrganization addCategory: #BuscaMinas!

SimpleSwitchMorph subclass: #BMCell
	instanceVariableNames: 'mouseAction contenedor refGame imagen i j numMinasAlrededor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BuscaMinas'!

!BMCell commentStamp: 'fj 6/2/2012 12:05' prior: 0!
refGame: Referencia a BMGame (cuando se hace click en un casilla, puede cambiar el estado del juego).!

!BMCell methodsFor: 'accessing' stamp: 'jameserazo 5/25/2012 11:25'!
contenedor

	^ contenedor! !

!BMCell methodsFor: 'accessing' stamp: 'jameserazo 5/25/2012 11:25'!
contenedor: anObject

	contenedor := anObject! !

!BMCell methodsFor: 'event handling' stamp: 'fj 6/8/2012 11:55'!
descubrirCasilla
	(contenedor = 1)
		ifTrue: 	[refGame explotarCasillas]
		ifFalse: 	[refGame destaparCasillas: self].! !

!BMCell methodsFor: 'as yet unclassified' stamp: 'fj 6/8/2012 07:45'!
explotarMina
      imagen image: (Form fromFileNamed: 'uno.jpg'). 
	imagen position: self position.
	self addMorph: imagen.! !

!BMCell methodsFor: 'accessing' stamp: 'FabioCern 6/8/2012 00:49'!
get_i

	^ i! !

!BMCell methodsFor: 'accessing' stamp: 'FabioCern 6/8/2012 00:50'!
get_j

	^ j! !

!BMCell methodsFor: 'initialization' stamp: 'FabioCern 6/8/2012 00:37'!
initialize
	super initialize.
	imagen := ImageMorph new. 	
	self label: ''.
	self borderWidth: 2.
	bounds := 0@4 corner: 20@20.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.! !

!BMCell methodsFor: 'initialization' stamp: 'jameserazo 5/25/2012 11:47'!
initialize: val
	contenedor:=val.
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@4 corner: 20@20.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.! !

!BMCell methodsFor: 'initialization' stamp: 'FabioCern 6/8/2012 00:48'!
initialize: ix at: jy
	super initialize.
	i := ix.
	j := jy.
	imagen := ImageMorph new. 	
	self label: ''.
	self borderWidth: 2.
	bounds := 0@4 corner: 20@20.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.! !

!BMCell methodsFor: 'accessing' stamp: 'jameserazo 5/25/2012 11:25'!
mouseAction

	^ mouseAction! !

!BMCell methodsFor: 'initialization' stamp: 'JamesErazo 5/18/2012 18:14'!
mouseAction: aBlock
	^mouseAction := aBlock! !

!BMCell methodsFor: 'event handling' stamp: 'fj 6/8/2012 10:46'!
mouseDown: evt
"En este mtodo se controlan los eventos clicks del raton"
"La accion no se controla aqui. ver el mtodo doButtonAction"

	"si se hace click izquierdo y el cursor se encuentra dentro el area"
	(evt redButtonPressed and: [self containsPoint: evt cursorPoint]) ifTrue: [
		"activar una sola vez"
		(self isOff and: [refGame jugando] ) ifTrue: [
				self turnOn.
				"self doButtonAction."
				self descubrirCasilla.
				"Transcript show: 'haciendo click en casilla'."
		].
		"cambiar de color"
		oldColor := self fillStyle.
	]
! !

!BMCell methodsFor: 'event handling' stamp: 'fj 6/2/2012 10:40'!
mouseMove: evt
"Se sobrecarga este mtodo para que la superclase no permita que el boton vuelva al estado original soltando el boton del raton"
! !

!BMCell methodsFor: 'event handling' stamp: 'fj 6/2/2012 10:20'!
mouseUp: evt
"Se sobrecarga este mtodo para que la superclase no permita que el boton vuelva al estado original soltando el boton del raton"
! !

!BMCell methodsFor: 'accessing' stamp: 'fj 6/8/2012 09:43'!
numMinasAlrededor
	^ numMinasAlrededor! !

!BMCell methodsFor: 'accessing' stamp: 'fj 6/8/2012 09:43'!
numMinasAlrededor: n
	numMinasAlrededor := n! !

!BMCell methodsFor: 'as yet unclassified' stamp: 'FabioCern 6/8/2012 00:53'!
posicionar: ix at: jy
	i := ix.
	j := jy.! !

!BMCell methodsFor: 'accessing' stamp: 'fj 6/2/2012 12:12'!
refGame: _refGame
	refGame  := _refGame.! !

!BMCell methodsFor: 'accessing' stamp: 'fj 6/2/2012 12:00'!
"modificado para preservar el tamao del widget"
setLabel: val
|oldWidth oldHeight|
	oldWidth := self width.
	oldHeight := self height.

	self label:val.
	
	self width: oldWidth.
	self height: oldHeight.! !

SimpleSwitchMorph subclass: #BMPanel
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BuscaMinas'!

!BMPanel methodsFor: 'initialize' stamp: 'JamesErazo 5/18/2012 18:14'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 20@20.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.
! !

!BMPanel methodsFor: 'access-ing' stamp: 'JamesErazo 5/18/2012 18:11'!
mouseAction: aBlock
	^mouseAction := aBlock! !

!BMPanel methodsFor: 'access-ing' stamp: 'jameserazo 5/25/2012 11:18'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #BMGame
	instanceVariableNames: 'cells jugando tope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BuscaMinas'!

!BMGame commentStamp: 'fj 6/2/2012 12:34' prior: 0!
cells: casilla del juego (matriz de BMCell)
jugando: Estado del juego (true para poder descubrir casillas/ false si hay una pausa)
!

!BMGame methodsFor: 'accessing' stamp: 'jameserazo 5/25/2012 11:27'!
cells

	^ cells! !

!BMGame methodsFor: 'accessing' stamp: 'jameserazo 5/25/2012 11:27'!
cells: anObject

	cells := anObject! !

!BMGame methodsFor: 'initialization' stamp: 'JamesErazo 5/18/2012 17:18'!
cellsPerSide
	"retorna el numero de filas y colomnas del tablero del juego - constante"
	^20
! !

!BMGame methodsFor: 'accessing' stamp: 'FabioCern 6/4/2012 20:43'!
contador 
	^ contador ! !

!BMGame methodsFor: 'accessing' stamp: 'FabioCern 6/3/2012 19:45'!
contador: anObject

	contador := anObject! !

!BMGame methodsFor: 'game-logic' stamp: 'fj 6/8/2012 10:00'!
contarNumMinasAlrededor
"Para cada casilla, cuenta cuantas minas hay en sus vecinas (min 0, mx 8)"

| i0 j0 U UR R DR D DL L UL|

cells do: [ :casilla |
	i0 := casilla get_i.
	j0 := casilla get_j. 

	casilla numMinasAlrededor: 0.
	
	"obtener las casillas vecinas si existen (Up Down Left Right UpRight UpLeft DownRight DownLeft)"
	U := cells at: i0-1 at: j0 ifInvalid: nil.
	D := cells at: i0+1 at: j0 ifInvalid: nil.
	L := cells at: i0 at: j0-1 ifInvalid: nil.
	R := cells at: i0 at: j0+1 ifInvalid: nil.
	UR := cells at: i0-1 at: j0+1 ifInvalid: nil.
	UL := cells at: i0-1 at: j0-1 ifInvalid: nil.
	DR := cells at: i0+1 at: j0+1 ifInvalid: nil.
	DL := cells at: i0+1 at: j0-1 ifInvalid: nil.

	"contar cuantas minas hay entre todas las vecinas"
	(U = nil) ifFalse:	 [casilla numMinasAlrededor:  casilla numMinasAlrededor + U contenedor].
	(D = nil) ifFalse:	 [casilla numMinasAlrededor:  casilla numMinasAlrededor + D contenedor].
	(L = nil) ifFalse:	 [casilla numMinasAlrededor:  casilla numMinasAlrededor + L contenedor].
	(R = nil) ifFalse:	 [casilla numMinasAlrededor:  casilla numMinasAlrededor + R contenedor].
	(UR = nil) ifFalse: [casilla numMinasAlrededor:  casilla numMinasAlrededor + UR contenedor].
	(UL = nil) ifFalse: [casilla numMinasAlrededor:  casilla numMinasAlrededor + UL contenedor].
	(DR = nil) ifFalse: [casilla numMinasAlrededor:  casilla numMinasAlrededor + DR contenedor].
	(DL = nil) ifFalse: [casilla numMinasAlrededor:  casilla numMinasAlrededor + DL contenedor].
	
	"casilla setLabel: casilla numMinasAlrededor asString ."
]! !

!BMGame methodsFor: 'game-logic' stamp: 'fj 6/8/2012 13:14'!
destaparCasillas: cell
	"basado en el algoritmo floodfill de wikipedia"
	|cola c w ww e ee U D c2| 

	cola := LIFOQueue new.


	cola push: cell.
	c := cola nextOrNil.
	[c = nil] whileFalse: [
		Transcript show: c contenedor asString.
		
		(c isOff or: c = cell) ifTrue: [
			(c numMinasAlrededor  > 0)
			 ifTrue: [c turnOn. c setLabel: c numMinasAlrededor asString ]	
			 ifFalse:[
				"Recorrer hacia la izquierda de la casilla"
				w := c.
				ww := cells at: (w get_i) at: ( w get_j -1) ifInvalid: nil.
				
				[ ww notNil] whileTrue: [
					(ww isOff) ifTrue: [
					w := ww.
					(w numMinasAlrededor > 0)
						 ifTrue: [ww := nil] "detener la busqueda hasta hallar una con vecinas que tengan minas"
						 ifFalse:  [ww := cells at: (w get_i) at: ( w get_j -1) ifInvalid: nil.]. "continuar hasta el borde"
					]
					ifFalse: [ww:= nil]. "detener si la casilla ya esta descubierta"
				].
			
				"Recorrer hacia la derecha de la casilla"
				e := c.
				ee := cells at: (e get_i) at: ( e get_j +1) ifInvalid: nil.
				
				[ee notNil ] whileTrue: [
					(ee isOff) ifTrue: [
					e := ee.
					(e numMinasAlrededor > 0)
						 ifTrue: [ee := nil] "detener la busqueda hasta hallar una con vecinas que tengan minas"
						 ifFalse:  [ee := cells at: (e get_i) at: ( e get_j+1 ) ifInvalid: nil.]. "continuar hasta el borde"
					]
					ifFalse: [ee := nil]. "detener si la casilla ya esta descubierta"
				].
			
				"recorrer de w a e"
				w get_j to: e get_j do: [ :j0 |
					U := cells at: (w get_i-1) at: j0 ifInvalid: nil.
					D := cells at: (w get_i+1) at: j0 ifInvalid: nil.
					
					"Empujar en la cola las casillas de arriba y abajo si no estn descubiertas (y si existen)"
					(U = nil) ifFalse: [ (U isOff) ifTrue: [cola push: U]. ]. 
					(D = nil) ifFalse: [(D isOff) ifTrue: [cola push: D]. ]. 
					
					"descubrir las casillas de w a e"
					c2 := cells at: (w get_i) at: j0.
					c2 turnOn.
				].
			
				"poner los indicadores /numeros en w y e si tienen minas alrededor"
				(w numMinasAlrededor > 0) ifTrue: [w setLabel: w numMinasAlrededor asString ].
				(e numMinasAlrededor > 0) ifTrue: [e setLabel: e numMinasAlrededor asString ].
			]. 				
			
		].
		
		c := cola nextOrNil.
	]. "end whileFalse"! !

!BMGame methodsFor: 'game-logic' stamp: 'FabioCern 6/8/2012 00:39'!
explotarCasillas
	"Si explota una bomba, explotan todas"

	cells do: [ :casilla | 
			(casilla contenedor = 1) ifTrue:
				[casilla explotarMina].
	].
	
jugando := false. "fracaso del juego".

! !

!BMGame methodsFor: 'initialization' stamp: 'fj 6/8/2012 08:36'!
initialize
	| sampleCell width height n |
	super initialize.
	tope := 0.
	n := self cellsPerSide.
	sampleCell := BMPanel new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].
	
	self contarNumMinasAlrededor. 
	jugando := true.
	
! !

!BMGame methodsFor: 'accessing' stamp: 'fj 6/2/2012 12:41'!
jugando
	"retorna el estado del juego"
	^jugando = true.! !

!BMGame methodsFor: 'game-logic' stamp: 'FabioCern 6/8/2012 01:24'!
newCellAt: i at: j
	| c origin rnd ix jy |
	c := BMCell new.
	
	
	origin := self innerBounds origin.
	self addMorph: c.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	c position: ((i - 1) * c width) @ ((j - 1+5) * c height) + origin.
	ix := ((i - 1) * c width).
	jy := ((j - 1+5) * c height) + origin.
	c posicionar: i at: j.
	Transcript show: ix.
	Transcript show: jy.
	Transcript show: '*'.
	
	rnd := self ponerMina.
	c contenedor: rnd.
	
	"hacer que la casilla referencia al juego"
	c refGame: self.
	^c
! !

!BMGame methodsFor: 'game-logic' stamp: 'fj 6/8/2012 12:20'!
ponerMina 
	"poner mina"
	| rnd |
	rnd:= Random new.
	rnd:=(rnd nextValue )*1.
	rnd:=rnd asInteger rem: 2.
	
	"(rnd = 1 and: tope = 5) ifTrue: [self contador: contador + 1]."
	(rnd = 1) 
		ifTrue: [self tope:  tope + 1].
		
	"c setLabel: rnd asString."
	(tope < 4) 
		ifTrue:  [rnd := 0]
		ifFalse: [rnd := 1].

	(tope = 4) ifTrue: [self tope: 0]	.
	
	^ rnd! !

!BMGame methodsFor: 'game-logic' stamp: 'FabioCern 6/5/2012 15:33'!
thisContextenvironmentllAt: i at: j
	| c origin rnd |
	c := BMCell new.

	origin := self innerBounds origin.
	self addMorph: c.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	c position: ((i - 1) * c width) @ ((j - 1+5) * c height) + origin.

	"poner mina"
	rnd:= Random new.
	rnd:=(rnd nextValue )*1.
	rnd:=rnd asInteger rem: 2.
	
	"c setLabel: rnd asString."
	c contenedor: rnd.
	
	"hacer que la casilla referencia al juego"
	c refGame: self.
	^c
! !

!BMGame methodsFor: 'game-logic' stamp: 'JamesErazo 5/18/2012 16:55'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].
! !

!BMGame methodsFor: 'accessing' stamp: 'FabioCern 6/5/2012 18:49'!
tope
	^ tope
	! !

!BMGame methodsFor: 'accessing' stamp: 'FabioCern 6/5/2012 18:50'!
tope: anObject

	tope := anObject! !

!BMGame methodsFor: 'as yet unclassified' stamp: 'jameserazo 5/25/2012 11:38'!
ubicarMinas: objetvalor inx: x iny: y
		cells 		
! !
